Attribute VB_Name = "modFIA"
Option Explicit

Private Const PI = 3.14159265

Public Function CrearModelo1( _
    ByVal sngLongitudTubo As Single, _
    ByVal sngRadioTubo As Single, _
    ByVal sngCaudal As Single, _
    ByVal sngDifusion As Single, _
    ByVal intAlto As Integer, _
    ByVal intAncho As Integer) As String
    
    
Dim sngVelLineal    As Single
Dim sngVelMax       As Single
Dim sngAltoCelda    As Single
Dim sngAnchoCelda   As Single
Dim sngDistAlCentro As Single
Dim sngVelocidadR0  As Single
Dim sngVelocidadR1  As Single
Dim sngVelocidadR2  As Single
Dim strModelo       As String
Dim strZona         As String
Dim strRule         As String
Dim intFilaCentro   As Integer
Dim intContador     As Integer
    

    sngVelLineal = sngCaudal / (60 * PI * sngRadioTubo ^ 2)
    sngVelMax = 2 * sngVelLineal
    sngAltoCelda = 2 * sngRadioTubo / intAlto
    sngAnchoCelda = sngLongitudTubo / intAncho
    intFilaCentro = intAlto / 2
    
    strModelo = "#Autogenerated FIA Model " & vbNewLine & _
        "#Fecha: " & Format(Date, "dd/mm/yyyy") & vbNewLine & _
        "#Parametros: " & vbNewLine & _
        "#      Longitud Tubo (cm): " & sngLongitudTubo & vbNewLine & _
        "#      Radio Tubo (cm)   : " & sngRadioTubo & vbNewLine & _
        "#      Caudal (cm^3/min) : " & sngCaudal & vbNewLine & _
        "#" & vbNewLine & _
        "#Modelo celular de " & intAlto & " x " & intAncho & vbNewLine & _
        vbNewLine & _
        "[top]" & vbNewLine & _
        "components :  fia " & vbNewLine & _
        vbNewLine & _
        "[fia] " & vbNewLine & _
        "type : cell " & vbNewLine & _
        "width : " & intAncho & vbNewLine & _
        "height : " & intAlto & vbNewLine & _
        "delay :  inertial " & vbNewLine & _
        "defaultDelayTime  : 1 " & vbNewLine & _
        "border :  nowrapped " & vbNewLine & _
        "neighbors : fia(-1,-1) fia(-1,0) fia(-1,1) " & vbNewLine & _
        "neighbors : fia(0,-1) fia(0,0) fia(0,1) " & vbNewLine & _
        "neighbors : fia(1,-1) fia(1,0) fia(1,1) " & vbNewLine & _
        vbNewLine & _
        "initialvalue : 0 " & vbNewLine
        
        strModelo = strModelo & vbNewLine & _
            "initialcellsvalue : fia.val" & vbNewLine & _
            "localtransition : fila0 " & vbNewLine

        'Definir las zonas
        For intContador = 0 To intAlto - 1
            strZona = "zone :  fila" & intContador & " { (" & intContador & ",0)..(" & _
                 intContador & "," & intAncho - 2 & ") }"
            strModelo = strModelo & strZona & vbNewLine
        Next
        
        'Definir las zonas
        For intContador = 0 To intAlto - 1
            strZona = "zone :  ultcol" & intContador & " { (" & intContador & "," & _
                 intAncho - 1 & ") }"
            strModelo = strModelo & strZona & vbNewLine
        Next
        
        strModelo = strModelo & vbNewLine & vbNewLine
        
        'Definir las reglas para todas las filas
        
        intContador = 0
        
        sngDistAlCentro = Abs(intContador - intFilaCentro) * sngAltoCelda
        sngVelocidadR1 = sngVelMax * (1 - (sngDistAlCentro / sngRadioTubo) ^ 2)
        
        sngDistAlCentro = Abs(intContador + 1 - intFilaCentro) * sngAltoCelda
        sngVelocidadR2 = sngVelMax * (1 - (sngDistAlCentro / sngRadioTubo) ^ 2)
        
        strRule = "[fila0]" & vbNewLine
        'strRule = strRule & "#Velocidad: " & SngToStr(sngVelocidadR1) & vbNewLine
        
        'Calcular la velocidad para demora 1
        sngVelocidadR1 = 1 / ((sngAnchoCelda / sngVelocidadR1) * 1000)
        sngVelocidadR2 = 1 / ((sngAnchoCelda / sngVelocidadR2) * 1000)
        strRule = strRule & "rule : { (0,1) * " & SngToStr(sngVelocidadR1) & " " & _
                " + (1,1) * " & SngToStr(sngVelocidadR2) & " " & _
                " + (1,0) * " & SngToStr(sngDifusion) & " " & _
                " + (0,0) * " & SngToStr(1 - sngVelocidadR1 * 2 - sngDifusion) & " } " & _
                " 1 " & _
                " { t }" & vbNewLine & vbNewLine
        
        strModelo = strModelo & strRule
        
        For intContador = 1 To intAlto - 2
            sngDistAlCentro = Abs(intContador - 1 - intFilaCentro) * sngAltoCelda
            sngVelocidadR0 = sngVelMax * (1 - (sngDistAlCentro / sngRadioTubo) ^ 2)

            sngDistAlCentro = Abs(intContador - intFilaCentro) * sngAltoCelda
            sngVelocidadR1 = sngVelMax * (1 - (sngDistAlCentro / sngRadioTubo) ^ 2)
            
            sngDistAlCentro = Abs(intContador + 1 - intFilaCentro) * sngAltoCelda
            sngVelocidadR2 = sngVelMax * (1 - (sngDistAlCentro / sngRadioTubo) ^ 2)
            
            strRule = "[fila" & intContador & "]" & vbNewLine
            'strRule = strRule & "#Velocidad: " & SngToStr(sngVelocidadR1) & vbNewLine
            
            'Calcular la velocidad para demora 1
            sngVelocidadR0 = 1 / ((sngAnchoCelda / sngVelocidadR0) * 1000)
            sngVelocidadR1 = 1 / ((sngAnchoCelda / sngVelocidadR1) * 1000)
            sngVelocidadR2 = 1 / ((sngAnchoCelda / sngVelocidadR2) * 1000)
            strRule = strRule & "rule : { (-1,1) * " & SngToStr(sngVelocidadR0) & " " & _
                    " + (0,1) * " & SngToStr(sngVelocidadR1) & " " & _
                    " + (1,1) * " & SngToStr(sngVelocidadR2) & " " & _
                    " + (1,0) * " & SngToStr(sngDifusion) & " " & _
                    " + (-1,0) * " & SngToStr(sngDifusion) & " " & _
                    " + (0,0) * " & SngToStr(1 - sngVelocidadR1 * 3 - sngDifusion * 2) & " } " & _
                    " 1 " & _
                    " { t }" & vbNewLine & vbNewLine
            
            strModelo = strModelo & strRule
                
        Next
        
        
        intContador = intAlto - 1
        
        sngDistAlCentro = Abs(intContador - 1 - intFilaCentro) * sngAltoCelda
        sngVelocidadR0 = sngVelMax * (1 - (sngDistAlCentro / sngRadioTubo) ^ 2)
        
        sngDistAlCentro = Abs(intContador - intFilaCentro) * sngAltoCelda
        sngVelocidadR1 = sngVelMax * (1 - (sngDistAlCentro / sngRadioTubo) ^ 2)
        
        strRule = "[fila" & intContador & "]" & vbNewLine
        'strRule = strRule & "#Velocidad: " & SngToStr(sngVelocidadR1) & vbNewLine
        
        'Calcular la velocidad para demora 1
        sngVelocidadR0 = 1 / ((sngAnchoCelda / sngVelocidadR0) * 1000)
        sngVelocidadR1 = 1 / ((sngAnchoCelda / sngVelocidadR1) * 1000)
        strRule = strRule & "rule : { (0,1) * " & SngToStr(sngVelocidadR1) & " " & _
                " + (-1,1) * " & SngToStr(sngVelocidadR0) & " " & _
                " + (-1,0) * " & SngToStr(sngDifusion) & " " & _
                " + (0,0) * " & SngToStr(1 - sngVelocidadR1 * 2 - sngDifusion) & " } " & _
                " 1 " & _
                " { t }" & vbNewLine & vbNewLine
        
        strModelo = strModelo & strRule
        
        
        'Definir las reglas para todas la ultima columna
        
        intContador = 0
        
        sngDistAlCentro = Abs(intContador - intFilaCentro) * sngAltoCelda
        sngVelocidadR1 = sngVelMax * (1 - (sngDistAlCentro / sngRadioTubo) ^ 2)
        
        sngDistAlCentro = Abs(intContador + 1 - intFilaCentro) * sngAltoCelda
        sngVelocidadR2 = sngVelMax * (1 - (sngDistAlCentro / sngRadioTubo) ^ 2)
        
        strRule = "[ultcol0]" & vbNewLine
        'strRule = strRule & "#Velocidad: " & SngToStr(sngVelocidadR1) & vbNewLine
        
        'Calcular la velocidad para demora 1
        sngVelocidadR1 = 1 / ((sngAnchoCelda / sngVelocidadR1) * 1000)
        sngVelocidadR2 = 1 / ((sngAnchoCelda / sngVelocidadR2) * 1000)
        strRule = strRule & "rule : { (1,0) * " & SngToStr(sngDifusion) & " " & _
                " + (0,0) * " & SngToStr(1 - sngVelocidadR1 * 2 - sngDifusion) & " } " & _
                " 1 " & _
                " { t }" & vbNewLine & vbNewLine
        
        strModelo = strModelo & strRule
        
        For intContador = 1 To intAlto - 2
            sngDistAlCentro = Abs(intContador - 1 - intFilaCentro) * sngAltoCelda
            sngVelocidadR0 = sngVelMax * (1 - (sngDistAlCentro / sngRadioTubo) ^ 2)

            sngDistAlCentro = Abs(intContador - intFilaCentro) * sngAltoCelda
            sngVelocidadR1 = sngVelMax * (1 - (sngDistAlCentro / sngRadioTubo) ^ 2)
            
            sngDistAlCentro = Abs(intContador + 1 - intFilaCentro) * sngAltoCelda
            sngVelocidadR2 = sngVelMax * (1 - (sngDistAlCentro / sngRadioTubo) ^ 2)
            
            strRule = "[ultcol" & intContador & "]" & vbNewLine
            'strRule = strRule & "#Velocidad: " & SngToStr(sngVelocidadR1) & vbNewLine
            
            'Calcular la velocidad para demora 1
            sngVelocidadR0 = 1 / ((sngAnchoCelda / sngVelocidadR0) * 1000)
            sngVelocidadR1 = 1 / ((sngAnchoCelda / sngVelocidadR1) * 1000)
            sngVelocidadR2 = 1 / ((sngAnchoCelda / sngVelocidadR2) * 1000)
            strRule = strRule & "rule : {(1,0) * " & SngToStr(sngDifusion) & " " & _
                    " + (-1,0) * " & SngToStr(sngDifusion) & " " & _
                    " + (0,0) * " & SngToStr(1 - sngVelocidadR1 * 3 - sngDifusion * 2) & " } " & _
                    " 1 " & _
                    " { t }" & vbNewLine & vbNewLine
            
            strModelo = strModelo & strRule
                
        Next
        
        
        intContador = intAlto - 1
        
        sngDistAlCentro = Abs(intContador - 1 - intFilaCentro) * sngAltoCelda
        sngVelocidadR0 = sngVelMax * (1 - (sngDistAlCentro / sngRadioTubo) ^ 2)
        
        sngDistAlCentro = Abs(intContador - intFilaCentro) * sngAltoCelda
        sngVelocidadR1 = sngVelMax * (1 - (sngDistAlCentro / sngRadioTubo) ^ 2)
        
        strRule = "[ultcol" & intContador & "]" & vbNewLine
        'strRule = strRule & "#Velocidad: " & SngToStr(sngVelocidadR1) & vbNewLine
        
        'Calcular la velocidad para demora 1
        sngVelocidadR0 = 1 / ((sngAnchoCelda / sngVelocidadR0) * 1000)
        sngVelocidadR1 = 1 / ((sngAnchoCelda / sngVelocidadR1) * 1000)
        strRule = strRule & "rule : { (-1,0) * " & SngToStr(sngDifusion) & " " & _
                " + (0,0) * " & SngToStr(1 - sngVelocidadR1 * 2 - sngDifusion) & " } " & _
                " 1 " & _
                " { t }" & vbNewLine & vbNewLine
        
        strModelo = strModelo & strRule
    
    CrearModelo1 = strModelo
    
End Function
    
Public Function CrearModelo2( _
    ByVal sngLongitudTubo As Single, _
    ByVal sngRadioTubo As Single, _
    ByVal sngCaudal As Single, _
    ByVal sngDifusion As Single, _
    ByVal intAlto As Integer, _
    ByVal intAncho As Integer) As String
    
    
Dim sngVelLineal    As Single
Dim sngVelMax       As Single
Dim sngAltoCelda    As Single
Dim sngAnchoCelda   As Single
Dim sngDistAlCentro As Single
Dim sngVelocidadR0  As Single
Dim sngVelocidadR1  As Single
Dim sngVelocidadR2  As Single
Dim strModelo       As String
Dim strZona         As String
Dim strRule         As String
Dim intFilaCentro   As Integer
Dim intContador     As Integer
    

    sngVelLineal = sngCaudal / (60 * PI * sngRadioTubo ^ 2)
    sngVelMax = 2 * sngVelLineal
    sngAltoCelda = 2 * sngRadioTubo / intAlto
    sngAnchoCelda = sngLongitudTubo / intAncho
    intFilaCentro = intAlto / 2
    
    strModelo = "#Autogenerated FIA Model " & vbNewLine & _
        "#Fecha: " & Format(Date, "dd/mm/yyyy") & vbNewLine & _
        "#Parametros: " & vbNewLine & _
        "#      Longitud Tubo (cm): " & sngLongitudTubo & vbNewLine & _
        "#      Radio Tubo (cm)   : " & sngRadioTubo & vbNewLine & _
        "#      Caudal (cm^3/min) : " & sngCaudal & vbNewLine & _
        "#" & vbNewLine & _
        "#Modelo celular de " & intAlto & " x " & intAncho & vbNewLine & _
        vbNewLine & _
        "[top]" & vbNewLine & _
        "components :  fia " & vbNewLine & _
        vbNewLine & _
        "[fia] " & vbNewLine & _
        "type : cell " & vbNewLine & _
        "width : " & intAncho & vbNewLine & _
        "height : " & intAlto & vbNewLine & _
        "delay :  inertial " & vbNewLine & _
        "defaultDelayTime  : 1 " & vbNewLine & _
        "border :  nowrapped " & vbNewLine & _
        "neighbors : fia(-1,-1) fia(-1,0) fia(-1,1) " & vbNewLine & _
        "neighbors : fia(0,-1) fia(0,0) fia(0,1) " & vbNewLine & _
        "neighbors : fia(1,-1) fia(1,0) fia(1,1) " & vbNewLine & _
        vbNewLine & _
        "initialvalue : 0 " & vbNewLine
        
        strModelo = strModelo & vbNewLine & _
            "initialcellsvalue : fia.val" & vbNewLine & _
            "localtransition : fila0 " & vbNewLine

        'Definir las zonas
        For intContador = 0 To intAlto - 1
            strZona = "zone :  fila" & intContador & " { (" & intContador & ",0)..(" & _
                 intContador & "," & intAncho - 2 & ") }"
            strModelo = strModelo & strZona & vbNewLine
        Next
        
        'Definir las zonas
        For intContador = 0 To intAlto - 1
            strZona = "zone :  ultcol" & intContador & " { (" & intContador & "," & _
                 intAncho - 1 & ") }"
            strModelo = strModelo & strZona & vbNewLine
        Next
        
        strModelo = strModelo & vbNewLine & vbNewLine
        
        'Definir las reglas para todas las filas
        
        intContador = 0
        
        sngDistAlCentro = Abs(intContador - intFilaCentro) * sngAltoCelda
        sngVelocidadR1 = sngVelMax * (1 - (sngDistAlCentro / sngRadioTubo) ^ 2)
        
        sngDistAlCentro = Abs(intContador + 1 - intFilaCentro) * sngAltoCelda
        sngVelocidadR2 = sngVelMax * (1 - (sngDistAlCentro / sngRadioTubo) ^ 2)
        
        strRule = "[fila0]" & vbNewLine
        'strRule = strRule & "#Velocidad: " & SngToStr(sngVelocidadR1) & vbNewLine
        
        'Calcular la velocidad para demora 1
        sngVelocidadR1 = 1 / ((sngAnchoCelda / sngVelocidadR1) * 1000)
        sngVelocidadR2 = 1 / ((sngAnchoCelda / sngVelocidadR2) * 1000)
        strRule = strRule & "rule : { (0,1) * " & SngToStr(sngVelocidadR1) & " " & _
                " + (1,0) * " & SngToStr(sngDifusion) & " " & _
                " + (0,0) * " & SngToStr(1 - sngVelocidadR1 - sngDifusion) & " } " & _
                " 1 " & _
                " { t }" & vbNewLine & vbNewLine
        
        strModelo = strModelo & strRule
        
        For intContador = 1 To intAlto - 2
            sngDistAlCentro = Abs(intContador - 1 - intFilaCentro) * sngAltoCelda
            sngVelocidadR0 = sngVelMax * (1 - (sngDistAlCentro / sngRadioTubo) ^ 2)

            sngDistAlCentro = Abs(intContador - intFilaCentro) * sngAltoCelda
            sngVelocidadR1 = sngVelMax * (1 - (sngDistAlCentro / sngRadioTubo) ^ 2)
            
            sngDistAlCentro = Abs(intContador + 1 - intFilaCentro) * sngAltoCelda
            sngVelocidadR2 = sngVelMax * (1 - (sngDistAlCentro / sngRadioTubo) ^ 2)
            
            strRule = "[fila" & intContador & "]" & vbNewLine
            'strRule = strRule & "#Velocidad: " & SngToStr(sngVelocidadR1) & vbNewLine
            
            'Calcular la velocidad para demora 1
            sngVelocidadR0 = 1 / ((sngAnchoCelda / sngVelocidadR0) * 1000)
            sngVelocidadR1 = 1 / ((sngAnchoCelda / sngVelocidadR1) * 1000)
            sngVelocidadR2 = 1 / ((sngAnchoCelda / sngVelocidadR2) * 1000)
            strRule = strRule & "rule : { (0,1) * " & SngToStr(sngVelocidadR1) & " " & _
                    " + (1,0) * " & SngToStr(sngDifusion) & " " & _
                    " + (-1,0) * " & SngToStr(sngDifusion) & " " & _
                    " + (0,0) * " & SngToStr(1 - sngVelocidadR1 - sngDifusion * 2) & " } " & _
                    " 1 " & _
                    " { t }" & vbNewLine & vbNewLine
            
            strModelo = strModelo & strRule
                
        Next
        
        
        intContador = intAlto - 1
        
        sngDistAlCentro = Abs(intContador - 1 - intFilaCentro) * sngAltoCelda
        sngVelocidadR0 = sngVelMax * (1 - (sngDistAlCentro / sngRadioTubo) ^ 2)
        
        sngDistAlCentro = Abs(intContador - intFilaCentro) * sngAltoCelda
        sngVelocidadR1 = sngVelMax * (1 - (sngDistAlCentro / sngRadioTubo) ^ 2)
        
        strRule = "[fila" & intContador & "]" & vbNewLine
        'strRule = strRule & "#Velocidad: " & SngToStr(sngVelocidadR1) & vbNewLine
        
        'Calcular la velocidad para demora 1
        sngVelocidadR0 = 1 / ((sngAnchoCelda / sngVelocidadR0) * 1000)
        sngVelocidadR1 = 1 / ((sngAnchoCelda / sngVelocidadR1) * 1000)
        strRule = strRule & "rule : { (0,1) * " & SngToStr(sngVelocidadR1) & " " & _
                " + (-1,0) * " & SngToStr(sngDifusion) & " " & _
                " + (0,0) * " & SngToStr(1 - sngVelocidadR1 - sngDifusion) & " } " & _
                " 1 " & _
                " { t }" & vbNewLine & vbNewLine
        
        strModelo = strModelo & strRule
        
        
        'Definir las reglas para todas la ultima columna
        
        intContador = 0
        
        sngDistAlCentro = Abs(intContador - intFilaCentro) * sngAltoCelda
        sngVelocidadR1 = sngVelMax * (1 - (sngDistAlCentro / sngRadioTubo) ^ 2)
        
        sngDistAlCentro = Abs(intContador + 1 - intFilaCentro) * sngAltoCelda
        sngVelocidadR2 = sngVelMax * (1 - (sngDistAlCentro / sngRadioTubo) ^ 2)
        
        strRule = "[ultcol0]" & vbNewLine
        'strRule = strRule & "#Velocidad: " & SngToStr(sngVelocidadR1) & vbNewLine
        
        'Calcular la velocidad para demora 1
        sngVelocidadR1 = 1 / ((sngAnchoCelda / sngVelocidadR1) * 1000)
        sngVelocidadR2 = 1 / ((sngAnchoCelda / sngVelocidadR2) * 1000)
        strRule = strRule & "rule : { (1,0) * " & SngToStr(sngDifusion) & " " & _
                " + (0,0) * " & SngToStr(1 - sngVelocidadR1 - sngDifusion) & " } " & _
                " 1 " & _
                " { t }" & vbNewLine & vbNewLine
        
        strModelo = strModelo & strRule
        
        For intContador = 1 To intAlto - 2
            sngDistAlCentro = Abs(intContador - 1 - intFilaCentro) * sngAltoCelda
            sngVelocidadR0 = sngVelMax * (1 - (sngDistAlCentro / sngRadioTubo) ^ 2)

            sngDistAlCentro = Abs(intContador - intFilaCentro) * sngAltoCelda
            sngVelocidadR1 = sngVelMax * (1 - (sngDistAlCentro / sngRadioTubo) ^ 2)
            
            sngDistAlCentro = Abs(intContador + 1 - intFilaCentro) * sngAltoCelda
            sngVelocidadR2 = sngVelMax * (1 - (sngDistAlCentro / sngRadioTubo) ^ 2)
            
            strRule = "[ultcol" & intContador & "]" & vbNewLine
            'strRule = strRule & "#Velocidad: " & SngToStr(sngVelocidadR1) & vbNewLine
            
            'Calcular la velocidad para demora 1
            sngVelocidadR0 = 1 / ((sngAnchoCelda / sngVelocidadR0) * 1000)
            sngVelocidadR1 = 1 / ((sngAnchoCelda / sngVelocidadR1) * 1000)
            sngVelocidadR2 = 1 / ((sngAnchoCelda / sngVelocidadR2) * 1000)
            strRule = strRule & "rule : {(1,0) * " & SngToStr(sngDifusion) & " " & _
                    " + (-1,0) * " & SngToStr(sngDifusion) & " " & _
                    " + (0,0) * " & SngToStr(1 - sngVelocidadR1 - sngDifusion * 2) & " } " & _
                    " 1 " & _
                    " { t }" & vbNewLine & vbNewLine
            
            strModelo = strModelo & strRule
                
        Next
        
        
        intContador = intAlto - 1
        
        sngDistAlCentro = Abs(intContador - 1 - intFilaCentro) * sngAltoCelda
        sngVelocidadR0 = sngVelMax * (1 - (sngDistAlCentro / sngRadioTubo) ^ 2)
        
        sngDistAlCentro = Abs(intContador - intFilaCentro) * sngAltoCelda
        sngVelocidadR1 = sngVelMax * (1 - (sngDistAlCentro / sngRadioTubo) ^ 2)
        
        strRule = "[ultcol" & intContador & "]" & vbNewLine
        'strRule = strRule & "#Velocidad: " & SngToStr(sngVelocidadR1) & vbNewLine
        
        'Calcular la velocidad para demora 1
        sngVelocidadR0 = 1 / ((sngAnchoCelda / sngVelocidadR0) * 1000)
        sngVelocidadR1 = 1 / ((sngAnchoCelda / sngVelocidadR1) * 1000)
        strRule = strRule & "rule : { (-1,0) * " & SngToStr(sngDifusion) & " " & _
                " + (0,0) * " & SngToStr(1 - sngVelocidadR1 - sngDifusion) & " } " & _
                " 1 " & _
                " { t }" & vbNewLine & vbNewLine
        
        strModelo = strModelo & strRule
    
    CrearModelo2 = strModelo
    
End Function
    
Public Function CrearModelo3( _
    ByVal sngLongitudTubo As Single, _
    ByVal sngRadioTubo As Single, _
    ByVal sngCaudal As Single, _
    ByVal sngDifusion As Single, _
    ByVal intAlto As Integer, _
    ByVal intAncho As Integer) As String
    
    
Dim sngVelLineal    As Single
Dim sngVelMax       As Single
Dim sngAltoCelda    As Single
Dim sngAnchoCelda   As Single
Dim sngDistAlCentro As Single

Dim sngVolCelda     As Single
Dim sngVol0         As Single
Dim sngVol1         As Single
Dim sngVol2         As Single
Dim sngVol3         As Single

Dim sngDistDif      As Single
Dim sngVelocidadR0  As Single
Dim sngVelocidadR1  As Single
Dim sngVelocidadR2  As Single
Dim strModelo       As String
Dim strZona         As String
Dim strRule         As String
Dim intContador     As Integer
    

    sngVelLineal = sngCaudal / (60 * PI * sngRadioTubo ^ 2)
    sngVelMax = 2 * sngVelLineal
    sngAltoCelda = sngRadioTubo / intAlto
    sngAnchoCelda = sngLongitudTubo / intAncho
    sngDistDif = Sqr(2 * sngDifusion * 10 ^ -3)
    
    strModelo = "#Autogenerated FIA Model 3" & vbNewLine & _
        "#Fecha: " & Format(Date, "dd/mm/yyyy") & vbNewLine & _
        "#Parametros: " & vbNewLine & _
        "#      Longitud Tubo (cm): " & sngLongitudTubo & vbNewLine & _
        "#      Radio Tubo (cm)   : " & sngRadioTubo & vbNewLine & _
        "#      Caudal (cm^3/min) : " & sngCaudal & vbNewLine & _
        "#" & vbNewLine & _
        "#Modelo celular de " & intAlto & " x " & intAncho & vbNewLine & _
        vbNewLine & _
        "[top]" & vbNewLine & _
        "components :  fia " & vbNewLine & _
        vbNewLine & _
        "[fia] " & vbNewLine & _
        "type : cell " & vbNewLine & _
        "width : " & intAncho & vbNewLine & _
        "height : " & intAlto & vbNewLine & _
        "delay :  inertial " & vbNewLine & _
        "defaultDelayTime  : 1 " & vbNewLine & _
        "border :  nowrapped " & vbNewLine & _
        "neighbors :  fia(-1,0)  " & vbNewLine & _
        "neighbors : fia(0,-1) fia(0,0) fia(0,1) " & vbNewLine & _
        "neighbors :  fia(1,0)  " & vbNewLine & _
        vbNewLine & _
        "initialvalue : 0.8 " & vbNewLine
        
        strModelo = strModelo & vbNewLine & _
            "initialcellsvalue : fia.val" & vbNewLine & _
            "localtransition : fila0 " & vbNewLine

        'Definir las zonas
        For intContador = 0 To intAlto - 1
            strZona = "zone :  fila" & intContador & " { (" & intContador & ",1)..(" & _
                 intContador & "," & intAncho - 1 & ") }"
            strModelo = strModelo & strZona & vbNewLine
        Next
        
        'Definir las zonas
        For intContador = 0 To intAlto - 1
            strZona = "zone :  ultcol" & intContador & " { (" & intContador & "," & _
                 0 & ") }"
            strModelo = strModelo & strZona & vbNewLine
        Next
        
        strModelo = strModelo & vbNewLine & vbNewLine
        
        'Definir las reglas para todas las filas
        
        intContador = 0
        
        sngDistAlCentro = intContador * sngAltoCelda
        sngVolCelda = PI * (sngAltoCelda ^ 2 + 2 * sngAltoCelda * sngDistAlCentro)
        
        sngVol2 = PI * ((sngDistAlCentro + sngAltoCelda - sngDistDif) * sngDistDif * 2 + sngDistDif ^ 2)
        sngVol3 = PI * ((sngDistAlCentro + sngAltoCelda) * sngDistDif * 2 + sngDistDif ^ 2)
        
        sngVelocidadR1 = sngVelMax * (1 - (sngDistAlCentro / sngRadioTubo) ^ 2)
              
        strRule = "[fila0]" & vbNewLine
        strRule = strRule & "%Velocidad: " & SngToStr(sngVelocidadR1) & vbNewLine
        
        'Calcular la velocidad para demora 1
        sngVelocidadR1 = 1 / ((sngAnchoCelda / sngVelocidadR1) * 1000)
        strRule = strRule & "rule : { (0,0) + (0,-1) * " & SngToStr(sngVelocidadR1) & " " & _
                " - (0,0) * " & SngToStr(sngVol2 / sngVolCelda) & _
                " - (0,0) * " & SngToStr(sngVelocidadR1) & _
                " +   ((1,0) * " & SngToStr(sngVol3) & " + (0,0) * " & SngToStr(sngVol2) & " ) * " & SngToStr(sngVol2 / (sngVol2 + sngVol3) / sngVolCelda) & " } " & _
                " 1 " & _
                " { t }" & vbNewLine & vbNewLine
        
        strModelo = strModelo & strRule
        
        For intContador = 1 To intAlto - 2
            sngDistAlCentro = intContador * sngAltoCelda
            
            sngVolCelda = PI * (sngAltoCelda ^ 2 + 2 * sngAltoCelda * sngDistAlCentro)
            sngVol0 = PI * ((sngDistAlCentro - sngDistDif) * sngDistDif * 2 + sngDistDif ^ 2)
            sngVol1 = PI * (sngDistAlCentro * sngDistDif * 2 + sngDistDif ^ 2)
            sngVol2 = PI * ((sngDistAlCentro + sngAltoCelda - sngDistDif) * sngDistDif * 2 + sngDistDif ^ 2)
            sngVol3 = PI * ((sngDistAlCentro + sngAltoCelda) * sngDistDif * 2 + sngDistDif ^ 2)

            sngVelocidadR1 = sngVelMax * (1 - (sngDistAlCentro / sngRadioTubo) ^ 2)
            
            'Calcular velocidad para demora 1
            sngVelocidadR1 = 1 / ((sngAnchoCelda / sngVelocidadR1) * 1000)
                    
            strRule = "[fila" & intContador & "]" & vbNewLine
            strRule = strRule & "rule : { (0,0) + (0,-1) * " & SngToStr(sngVelocidadR1) & " " & _
                " - (0,0) * " & SngToStr(sngVol1 / sngVolCelda) & _
                " - (0,0) * " & SngToStr(sngVol2 / sngVolCelda) & _
                " - (0,0) * " & SngToStr(sngVelocidadR1) & _
                " +   ((1,0) * " & SngToStr(sngVol3) & " + (0,0) * " & SngToStr(sngVol2) & " ) * " & SngToStr(sngVol2 / (sngVol2 + sngVol3) / sngVolCelda) & _
                " + ((-1,0) * " & SngToStr(sngVol0) & " + (0,0) * " & SngToStr(sngVol1) & " ) * " & SngToStr(sngVol1 / (sngVol1 + sngVol0) / sngVolCelda) & " } " & _
                " 1 " & _
                " { t }" & vbNewLine & vbNewLine
            
            strModelo = strModelo & strRule
                
        Next
        
        
        intContador = intAlto - 1
        
        sngDistAlCentro = intContador * sngAltoCelda
        
        sngVolCelda = PI * (sngAltoCelda ^ 2 + 2 * sngAltoCelda * sngDistAlCentro)
        sngVol0 = PI * ((sngDistAlCentro - sngDistDif) * sngDistDif * 2 + sngDistDif ^ 2)
        sngVol1 = PI * (sngDistAlCentro * sngDistDif * 2 + sngDistDif ^ 2)

        sngVelocidadR1 = sngVelMax * (1 - (sngDistAlCentro / sngRadioTubo) ^ 2)
        
        'Calcular velocidad para demora 0
        sngVelocidadR1 = 1 / ((sngAnchoCelda / sngVelocidadR1) * 1000)
                
        strRule = "[fila" & intContador & "]" & vbNewLine
        strRule = strRule & "rule : { (0,0) + (0,-1) * " & SngToStr(sngVelocidadR1) & " " & _
            " - (0,0) * " & SngToStr(sngVol1 / sngVolCelda) & _
            " - (0,0) * " & SngToStr(sngVelocidadR1) & _
            " + ((-1,0) * " & SngToStr(sngVol0) & " + (0,0) * " & SngToStr(sngVol1) & " ) * " & SngToStr(sngVol1 / (sngVol1 + sngVol0) / sngVolCelda) & " } " & _
            " 1 " & _
            " { t }" & vbNewLine & vbNewLine
            
           
        strModelo = strModelo & strRule
        
        
        'Definir las reglas para todas la ultima columna
        
        intContador = 0
        
        sngDistAlCentro = intContador * sngAltoCelda
        sngVolCelda = PI * (sngAltoCelda ^ 2 + 2 * sngAltoCelda * sngDistAlCentro)
        
        sngVol2 = PI * ((sngDistAlCentro + sngAltoCelda - sngDistDif) * sngDistDif * 2 + sngDistDif ^ 2)
        sngVol3 = PI * ((sngDistAlCentro + sngAltoCelda) * sngDistDif * 2 + sngDistDif ^ 2)
        
                      
        strRule = "[ultcol0]" & vbNewLine
        strRule = strRule & "%Velocidad: " & SngToStr(sngVelocidadR1) & vbNewLine
        
        strRule = strRule & "rule : { (0,0) + 0.8 * " & SngToStr(sngVelocidadR1) & " " & _
                " - (0,0) * " & SngToStr(sngVol2 / sngVolCelda) & _
                " - (0,0) * " & SngToStr(sngVelocidadR1) & _
                " +   ((1,0) * " & SngToStr(sngVol3) & " + (0,0) * " & SngToStr(sngVol2) & " ) * " & SngToStr(sngVol2 / (sngVol2 + sngVol3) / sngVolCelda) & " } " & _
                " 1 " & _
                " { t }" & vbNewLine & vbNewLine
        
        strModelo = strModelo & strRule
        
        For intContador = 1 To intAlto - 2
            sngDistAlCentro = intContador * sngAltoCelda
            
            sngVolCelda = PI * (sngAltoCelda ^ 2 + 2 * sngAltoCelda * sngDistAlCentro)
            sngVol0 = PI * ((sngDistAlCentro - sngDistDif) * sngDistDif * 2 + sngDistDif ^ 2)
            sngVol1 = PI * (sngDistAlCentro * sngDistDif * 2 + sngDistDif ^ 2)
            sngVol2 = PI * ((sngDistAlCentro + sngAltoCelda - sngDistDif) * sngDistDif * 2 + sngDistDif ^ 2)
            sngVol3 = PI * ((sngDistAlCentro + sngAltoCelda) * sngDistDif * 2 + sngDistDif ^ 2)

                                
            strRule = "[ultcol" & intContador & "]" & vbNewLine
            strRule = strRule & "rule : { (0,0) + 0.8 * " & SngToStr(sngVelocidadR1) & " " & _
                " - (0,0) * " & SngToStr(sngVol1 / sngVolCelda) & _
                " - (0,0) * " & SngToStr(sngVol2 / sngVolCelda) & _
                " - (0,0) * " & SngToStr(sngVelocidadR1) & _
                " +   ((1,0) * " & SngToStr(sngVol3) & " + (0,0) * " & SngToStr(sngVol2) & " ) * " & SngToStr(sngVol2 / (sngVol2 + sngVol3) / sngVolCelda) & _
                " + ((-1,0) * " & SngToStr(sngVol0) & " + (0,0) * " & SngToStr(sngVol1) & " ) * " & SngToStr(sngVol1 / (sngVol1 + sngVol0) / sngVolCelda) & " } " & _
                " 1 " & _
                " { t }" & vbNewLine & vbNewLine
            
            strModelo = strModelo & strRule
                
        Next
        
        
        intContador = intAlto - 1
        
        sngDistAlCentro = intContador * sngAltoCelda
        
        sngVolCelda = PI * (sngAltoCelda ^ 2 + 2 * sngAltoCelda * sngDistAlCentro)
        sngVol0 = PI * ((sngDistAlCentro - sngDistDif) * sngDistDif * 2 + sngDistDif ^ 2)
        sngVol1 = PI * (sngDistAlCentro * sngDistDif * 2 + sngDistDif ^ 2)

                        
        strRule = "[ultcol" & intContador & "]" & vbNewLine
        strRule = strRule & "rule : { (0,0) + 0.8 * " & SngToStr(sngVelocidadR1) & " " & _
            " - (0,0) * " & SngToStr(sngVol1 / sngVolCelda) & _
            " - (0,0) * " & SngToStr(sngVelocidadR1) & _
            " + ((-1,0) * " & SngToStr(sngVol0) & " + (0,0) * " & SngToStr(sngVol1) & " ) * " & SngToStr(sngVol1 / (sngVol1 + sngVol0) / sngVolCelda) & " } " & _
            " 1 " & _
            " { t }" & vbNewLine & vbNewLine
            
           
        strModelo = strModelo & strRule
        
        CrearModelo3 = strModelo
    
End Function
    
Public Function CrearModelo4( _
    ByVal strNombreArchivo As String, _
    ByVal strNombreArchivoVal As String, _
    ByVal sngLongitudTubo As Single, _
    ByVal sngRadioTubo As Single, _
    ByVal sngCaudal As Single, _
    ByVal sngDifusion As Single, _
    ByVal intAlto As Integer, _
    ByVal intAncho As Integer) As String
    
    
Dim sngVelLineal    As Single
Dim sngVelMax       As Single
Dim sngAltoCelda    As Single
Dim sngAnchoCelda   As Single
Dim sngDistAlCentro As Single

Dim sngVolCelda     As Single
Dim sngVol0         As Single
Dim sngVol1         As Single
Dim sngVol2         As Single
Dim sngVol3         As Single

Dim sngDistDif      As Single
Dim sngVelocidadR0  As Single
Dim sngVelocidadR1  As Single
Dim sngVelocidadR2  As Single
Dim intFrecuency    As Integer
Dim strModelo       As String
Dim strDemora       As String
Dim strZona         As String
Dim strRule         As String
Dim intContador     As Integer
Dim intContador2    As Integer
Dim intFileHandle   As Integer
    

    intFileHandle = FreeFile()
    Open strNombreArchivo For Output As #intFileHandle
    
    sngVelLineal = sngCaudal / (60 * PI * sngRadioTubo ^ 2)
    sngVelMax = 2 * sngVelLineal
    sngAltoCelda = sngRadioTubo / intAlto
    sngAnchoCelda = sngLongitudTubo / intAncho
    intFrecuency = (sngAltoCelda / 2) ^ 2 / sngDifusion
    
    
    '(ancho de celda ) / (VelMax*(1 - (cellPos(0) * alto celda + alto celda/2)^2 / radio^2)) * 1000
    strDemora = "{ " & SngToStr(sngAnchoCelda) & " / ( " & _
        SngToStr(sngVelMax) & " * ( 1 - power( cellPos(0) * " & _
        SngToStr(sngAltoCelda) & " + " & SngToStr(sngAltoCelda / 2) & _
        " , 2) / " & SngToStr(sngRadioTubo ^ 2) & " )) * 1000 }"
        
    Print #intFileHandle, "[Top]" & vbNewLine
    
    Print #intFileHandle, "components :  fia generador@ConstGenerator" & vbNewLine
    Print #intFileHandle, "in : solExterna" & vbNewLine
    Print #intFileHandle, "link : out@generador difundir@fia" & vbNewLine
    Print #intFileHandle, "link : solExterna solExterna@fia" & vbNewLine
    Print #intFileHandle, vbNewLine
    
    Print #intFileHandle, "[fia]" & vbNewLine
    Print #intFileHandle, "in : difundir solExterna" & vbNewLine
    Print #intFileHandle, "type : cell" & vbNewLine
    Print #intFileHandle, _
        "width : " & intAncho & vbNewLine & _
        "height : " & intAlto & vbNewLine & _
        "delay :   inertial" & vbNewLine & _
        "defaultDelayTime  : 1 " & vbNewLine & _
        "border :   nowrapped " & vbNewLine & _
        "neighbors : fia(-1,-1) fia(-1,0) fia(-1,1) " & vbNewLine & _
        "neighbors : fia(0,-1) fia(0,0) fia(0,1) " & vbNewLine & _
        "neighbors : fia(1,-1) fia(1,0) fia(1,1) " & vbNewLine
    
    Print #intFileHandle, vbNewLine
    Print #intFileHandle, "initialvalue : 0.8" & vbNewLine & _
        "initialcellsvalue : " & strNombreArchivoVal & vbNewLine & _
        "localtransition :  transporte " & vbNewLine
    
    Print #intFileHandle, vbNewLine
    
    Print #intFileHandle, "[generador]" & vbNewLine & _
        "frecuency : 00:00:00:" & Format(intFrecuency, "000") & vbNewLine
        
    Print #intFileHandle, "[transporte]" & vbNewLine & _
        "rule : { (0,-1) } " & strDemora & " { cellpos(1) != 0 } " & vbNewLine & _
        "rule : { 0.8 } " & strDemora & " { cellpos(1) = 0 }"
    
    Print #intFileHandle, vbNewLine
    Print #intFileHandle, "[difusion]" & vbNewLine & _
        "rule : { ( (-1,0) * ( 2 * ( cellpos ( 0 ) - 1 ) + 1) + (0,0) * ( 2*cellpos(0) + 1)  + (1,0) * ( 2 * ( cellpos ( 0 ) + 1 ) + 1 ) ) / ( ( 2 * ( cellpos( 0 ) - 1 ) + 1) + ( 2 * cellpos(0) + 1)  + ( 2 * ( cellpos( 0 ) + 1 ) + 1 )) } " & strDemora & " { cellpos(0) != 0 AND cellpos(0) != " & intAlto - 1 & " } " & vbNewLine & _
        "rule : { ((0,0) * ( 2*cellpos(0) + 1)  + (1,0) * (2*(cellpos(0)+1) + 1 ) ) / (( 2*cellpos(0) + 1)  + (2*(cellpos(0)+1) + 1 )) } " & strDemora & "   { cellpos(0) = 0 " & " } " & vbNewLine & _
        "rule : { ((-1,0)*( 2*(cellpos(0) - 1 ) + 1) + (0,0) * ( 2*cellpos(0) + 1)) / (( 2*(cellpos(0) - 1) + 1) + ( 2*cellpos(0) + 1)) } " & strDemora & " { cellpos(0) = " & intAlto - 1 & " } " & vbNewLine

    Print #intFileHandle, vbNewLine
    Print #intFileHandle, "[fia]" & vbNewLine
    
    For intContador = 0 To intAlto - 1
        For intContador2 = 0 To intAncho - 1
        
        Print #intFileHandle, "link : difundir difundir@fia(" & intContador & "," & intContador2 & ")" & vbNewLine
        Print #intFileHandle, "PortInTransition : difundir@fia(" & intContador & "," & intContador2 & ") difusion" & vbNewLine
        Print #intFileHandle, vbNewLine
        Next
    Next
    
    Close (intFileHandle)
    CrearModelo4 = ""
    
    
End Function

Public Function CrearModelo5( _
    ByVal strNombreArchivo As String, _
    ByVal strNombreArchivoVal As String, _
    ByVal sngLongitudTubo As Single, _
    ByVal sngRadioTubo As Single, _
    ByVal sngCaudal As Single, _
    ByVal sngDifusion As Single, _
    ByVal intAlto As Integer, _
    ByVal intAncho As Integer) As String
    
    
Dim sngVelLineal    As Single
Dim sngVelMax       As Single
Dim sngAltoCelda    As Single
Dim sngAnchoCelda   As Single
Dim sngDistAlCentro As Single

Dim sngVolCelda     As Single
Dim sngVol0         As Single
Dim sngVol1         As Single
Dim sngVol2         As Single
Dim sngVol3         As Single

Dim sngDistDif      As Single
Dim sngVelocidadR0  As Single
Dim sngVelocidadR1  As Single
Dim sngVelocidadR2  As Single
Dim intFrecuency    As Integer
Dim strModelo       As String
Dim strDemora       As String
Dim strZona         As String
Dim strRule         As String
Dim intContador     As Integer
Dim intContador2    As Integer
Dim intFileHandle   As Integer
    

    intFileHandle = FreeFile()
    Open strNombreArchivo For Output As #intFileHandle
    
    sngVelLineal = sngCaudal / (60 * PI * sngRadioTubo ^ 2)
    sngVelMax = 2 * sngVelLineal
    sngAltoCelda = sngRadioTubo / intAlto
    sngAnchoCelda = sngLongitudTubo / intAncho
    intFrecuency = (sngAltoCelda / 2) ^ 2 / sngDifusion
    
    
    '(ancho de celda ) / (VelMax*(1 - (cellPos(0) * alto celda + alto celda/2)^2 / radio^2)) * 1000
    strDemora = "{ " & SngToStr(sngAnchoCelda) & " / ( " & _
        SngToStr(sngVelMax) & " * ( 1 - power( cellPos(0) * " & _
        SngToStr(sngAltoCelda) & " + " & SngToStr(sngAltoCelda / 2) & _
        " , 2) / " & SngToStr(sngRadioTubo ^ 2) & " )) * 1000 }"
        
    Print #intFileHandle, "[Top]" & vbNewLine
    
    Print #intFileHandle, "components :  fia generador@ConstGenerator" & vbNewLine
    Print #intFileHandle, "in : solExterna" & vbNewLine
    Print #intFileHandle, "link : out@generador difundir@fia" & vbNewLine
    Print #intFileHandle, "link : solExterna solExterna@fia" & vbNewLine
    Print #intFileHandle, vbNewLine
    
    Print #intFileHandle, "[fia]" & vbNewLine
    Print #intFileHandle, "in : difundir solExterna" & vbNewLine
    Print #intFileHandle, "type : cell" & vbNewLine
    Print #intFileHandle, _
        "width : " & intAncho & vbNewLine & _
        "height : " & intAlto & vbNewLine & _
        "delay :   inertial" & vbNewLine & _
        "defaultDelayTime  : 1 " & vbNewLine & _
        "border :   nowrapped " & vbNewLine & _
        "neighbors : fia(-1,-1) fia(-1,0) fia(-1,1) " & vbNewLine & _
        "neighbors : fia(0,-1) fia(0,0) fia(0,1) " & vbNewLine & _
        "neighbors : fia(1,-1) fia(1,0) fia(1,1) " & vbNewLine
    
    Print #intFileHandle, vbNewLine
    Print #intFileHandle, "initialvalue : 0.8" & vbNewLine & _
        "initialcellsvalue : " & strNombreArchivoVal & vbNewLine & _
        "localtransition :  transporte " & vbNewLine
    
    Print #intFileHandle, vbNewLine
    
    Print #intFileHandle, "[generador]" & vbNewLine & _
        "frecuency : 00:00:00:" & Format(intFrecuency, "000") & vbNewLine
        
    Print #intFileHandle, "[transporte]" & vbNewLine & _
        "rule : { (0,-1) } " & strDemora & " { cellpos(1) != 0 } " & vbNewLine & _
        "rule : { 0.8 } " & strDemora & " { cellpos(1) = 0 }"
    
    Print #intFileHandle, vbNewLine
    Print #intFileHandle, "[difusion]" & vbNewLine & _
        "rule : { ( (-1,0) * ( 2 * ( cellpos ( 0 ) - 1 ) + 1) + (0,0) * ( 2*cellpos(0) + 1)  + (1,0) * ( 2 * ( cellpos ( 0 ) + 1 ) + 1 ) ) / ( ( 2 * ( cellpos( 0 ) - 1 ) + 1) + ( 2 * cellpos(0) + 1)  + ( 2 * ( cellpos( 0 ) + 1 ) + 1 )) } { sigma } { cellpos(0) != 0 AND cellpos(0) != " & intAlto - 1 & " } " & vbNewLine & _
        "rule : { ((0,0) * ( 2*cellpos(0) + 1)  + (1,0) * (2*(cellpos(0)+1) + 1 ) ) / (( 2*cellpos(0) + 1)  + (2*(cellpos(0)+1) + 1 )) } { sigma }   { cellpos(0) = 0 " & " } " & vbNewLine & _
        "rule : { ((-1,0)*( 2*(cellpos(0) - 1 ) + 1) + (0,0) * ( 2*cellpos(0) + 1)) / (( 2*(cellpos(0) - 1) + 1) + ( 2*cellpos(0) + 1)) } { sigma } { cellpos(0) = " & intAlto - 1 & " } " & vbNewLine

    Print #intFileHandle, vbNewLine
    Print #intFileHandle, "[fia]" & vbNewLine
    
    For intContador = 0 To intAlto - 1
        For intContador2 = 0 To intAncho - 1
        
        Print #intFileHandle, "link : difundir difundir@fia(" & intContador & "," & intContador2 & ")" & vbNewLine
        Print #intFileHandle, "PortInTransition : difundir@fia(" & intContador & "," & intContador2 & ") difusion" & vbNewLine
        Print #intFileHandle, vbNewLine
        Next
    Next
    
    Close (intFileHandle)
    CrearModelo5 = ""
    
    
End Function

    
    
Public Function CrearValoresIniciales( _
    ByVal sngLongitudTubo As Single, _
    ByVal sngRadioTubo As Single, _
    ByVal intAlto As Integer, _
    ByVal intAncho As Integer, _
    ByVal sngValorInicial As Single, _
    ByVal sngAnchoInicial As Single, _
    ByVal strNombreArchivo As String) As String
    
    

Dim sngAltoCelda    As Single
Dim sngAnchoCelda   As Single
Dim strCelda        As String
Dim strValores      As String
Dim intAnchoZona    As Integer
Dim intContador1    As Integer
Dim intContador2    As Integer
    
    Dim intFileHandle As Integer
    
    intFileHandle = FreeFile
    
    Open strNombreArchivo For Output As #intFileHandle
    
    sngAltoCelda = 2 * sngRadioTubo / intAlto
    sngAnchoCelda = sngLongitudTubo / intAncho
    intAnchoZona = sngAnchoInicial / sngAnchoCelda
    
    
    For intContador1 = 0 To intAnchoZona
        For intContador2 = 0 To intAlto - 1
            Print #intFileHandle, " (" & intContador2 & "," & intContador1 & ") = " & SngToStr(sngValorInicial)
            
        Next
    Next
        
    Close #intFileHandle
    
End Function
    

    


Private Function SngToStr(ByVal sngValue As Single) As String
'Devuelve un string con el valor del numero sin el E y con el punto
'como separador decimal

    Dim strValor As String
    
    strValor = Format(sngValue, "###########0.0##################")
    strValor = Replace(strValor, ",", ".")
    
    SngToStr = strValor

End Function


