/*******************************************************************
*
*  DESCRIPTION: class Generator
*
*  AUTHOR: Amir Barylko & Jorge Beyoglonian 
*
*  EMAIL: mailto://amir@dc.uba.ar
*         mailto://jbeyoglo@dc.uba.ar
*
*  DATE: 27/6/1998
*
*******************************************************************/

/** include files **/
#include "constGenerat.h"
#include "message.h"       // class InternalMessage 
#include "strutil.h"       // str2Value( ... )
#include "mainsimu.h"      // class Simulator
#include "distri.h"        // class Distribution 


/*******************************************************************
* Function Name: Generator
* Description: constructor
********************************************************************/
constGenerator::constGenerator( const string &name )
	: Atomic( name )
	, out( addOutputPort( "out" ) )
{
	// str2Int( MainSimulator::Instance().getParameter( description(), "initial" ) );
 	string time( MainSimulator::Instance().getParameter( description(), "frecuency" ));

	if( time != "" ) {
		preparationTime = time;
	}	

}

/*******************************************************************
* Function Name: initFunction
********************************************************************/
Model &constGenerator::initFunction()
{
	holdIn(active, preparationTime ) ;
	return *this ;
}

/*******************************************************************
* Function Name: internalFunction
********************************************************************/
Model &constGenerator::internalFunction( const InternalMessage & )
{
	holdIn( active, preparationTime) ;
	return *this;
}

/*******************************************************************
* Function Name: outputFunction
********************************************************************/
Model &constGenerator::outputFunction( const InternalMessage &msg )
{
	sendOutput( msg.time(), out, (Value) 0 ) ;
	return *this ;
}
