/*******************************************************************
*								   *
*  DESCRIPTION: 
*								   *
********************************************************************/

#ifndef __GENERATOR_H
#define __GENERATOR_H

/** include files **/

/** my include files **/
#include "atomic.h"     // class Atomic
#include "except.h"     // class InvalidMessageException

/** forward declarations **/
class Distribution ;
 
/** declarations **/
class constGenerator : public Atomic
{
public:
	constGenerator( const string &name = "constGenerator" );  // Default constructor
	virtual string className() const ;

protected:
	Model &initFunction() ;
	Model &externalFunction( const ExternalMessage & ) ;
	Model &internalFunction( const InternalMessage & );
	Model &outputFunction( const InternalMessage & );

private:
	Port &out;
		Time preparationTime; 		

};	// class constGenerator

/** inline **/

inline
string constGenerator::className() const
{
	return "constGenerator" ;
}

inline
Model &constGenerator::externalFunction( const ExternalMessage & )
{
	throw InvalidMessageException() ;
}

#endif   //__constGenerator_H
